# session-middleware

[![npm](https://img.shields.io/npm/v/@sr-net/session-middleware.svg)](https://www.npmjs.com/package/@sr-net/session-middleware)
[![TravisCI](https://img.shields.io/travis/sr-net/session-middleware.svg)](https://travis-ci.org/sr-net/session-middleware)
[![Coveralls](https://img.shields.io/coveralls/sr-net/session-middleware.svg)](https://coveralls.io/github/sr-net/session-middleware)
[![David](https://img.shields.io/david/sr-net/session-middleware.svg)](https://david-dm.org/sr-net/session-middleware)

## Usage

The middleware needs a [`sr-net/auth`](https://github.com/sr-net/auth) service to use. Clone and run it locally before using this middleware.

```ts
import { Session } from '@sr-net/session-middleware'

app.use(
  Session({
    url: 'http://localhost:3100', // Url to running auth service
    domain: 'stratroulette.net', // Domain server is running on
  })
)

app.use(ctx => {
  ctx.session.id // Session ID
  ctx.session.maxAge // Session lifetime
  ctx.session.user // Session's User, if logged in
  ctx.session.isLoggedIn // Alias for !!ctx.session.user
  ctx.session.identifier // User UUID if logged in, otherwise Session ID

  ctx.session.foo = 'baz' // Set any variable and it will be saved to the Auth service
})
```

### Testing

`yarn test`
