import { Middleware as IMiddleware } from 'koa';
export declare enum Access {
    OWNER = "OWNER",
    SIEGE = "SIEGE"
}
export declare enum AuthorTypes {
    SUBMISSION = "submission",
    REDDIT = "reddit",
    GITHUB = "github",
    YOUTUBE = "youtube",
    TWITCH = "twitch"
}
export interface IAccount {
    name: string;
    unique: string;
    profileUrl: string;
}
export interface IUser {
    uuid: string;
    name: string;
    primary: AuthorTypes;
    reddit: IAccount | null;
    github: IAccount | null;
    youtube: IAccount | null;
    twitch: IAccount | null;
    points: number;
    permissions: Access[];
}
export interface ISession {
    id: string;
    maxAge: number;
    user?: IUser;
    [key: string]: any;
}
interface IContextSession extends ISession {
    isLoggedIn: boolean;
    identifier: string;
}
export interface ISessionMiddlewareOptions {
    url?: string;
    domain?: string;
}
export declare function Session(optionsIn?: ISessionMiddlewareOptions): IMiddleware;
declare module 'koa' {
    interface Context {
        session: IContextSession;
    }
}
export {};
